/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of API.xs. Do not edit this file, edit API.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "API.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stdio.h>

#include "ppport.h"

#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>

#if LUA_VERSION_NUM < 501

#error "This requires at least version 5.1 of Lua"

#endif

#include "const-c.inc"

#define MY_CXT_KEY "Lua::API::_guts" XS_VERSION

typedef struct {
    HV *OOB;
} my_cxt_t;

START_MY_CXT


/*-------------------------------------------------------------------*/
/* Support for out-of-band data

   Lua interfaces to C functions, not Perl ones, and they must be
   declared at compile time (can't create them on the fly) so we
   use trampoline C functions to call Perl.  Sometimes its possible
   to attach routing information (via Lua C closures) so that the
   trampoline knows which Perl function to call.  Sometimes its not.

   In the latter case, for certain classes of uses (such as hooks) we
   can deduce which Perl function to call based upon some extra piece
   of data needs to be stored somewhere.  This provides that facility.

   We keep track of the out-of-band data in a Perl hash, keyed off of
   a pointer address (like an inside-out object). We could
   have created a LuaInterpreter Object which contains both the
   lua_State pointer and any other instance specific data, but that
   makes using the automated XS calling of Lua functions much more
   messy.

*/

/* The OOB hash stores data keyed off of a pointer.  Its values are
   hashes */

static
HV* get_oob_entry( void *ptr )
{
    dMY_CXT;
    HV* oob;

    {
	SV ** svp = hv_fetch( MY_CXT.OOB, (const char*) &ptr, sizeof(ptr), 1 );
	if ( svp == NULL )
	    croak( "Perl Lua::API: error getting OOB hash\n" );

	/* if not defined, has not yet been created; do so */
	if ( ! SvOK( *svp) )
	{
	    HV *t_hv = newHV();
	    SV *t_rv = newRV_inc( (SV*) t_hv );
	    svp = hv_store( MY_CXT.OOB, (const char*) &ptr, sizeof(ptr), t_rv, 0);
	}

	oob = (HV*) SvRV(*svp);

	if ( SVt_PVHV != SvTYPE(oob) )
	    croak( "Perl Lua::API: OOB entry  %p is not a hash\n", (void *) ptr );
    }

    return oob;
}

static
SV * delete_oob_entry( void *ptr )
{
    dMY_CXT;

    return hv_delete( MY_CXT.OOB, (const char*) &ptr, sizeof(ptr), 0 );
}


/*-------------------------------------------------------------------*/
/* Mapping lua_State* to Lua::API::State objects

   When Lua calls the trampolines, its passes in a lua_State*.  Perl,
   however, wants a Lua::API::State object.  We could create them on the
   fly from the lua_State* (since there's nothing in the Lua::API::State
   object but a lua_State*), but then Lua::API::State::DESTROY would get
   called whenever the temporary objects are destroyed, which
   is not good.

   Instead, we keep track of the original Lua::API::State object in the OOB
   hash.
 */

static
SV* get_Perl_object( void *ptr )
{
    SV** svp = hv_fetch( get_oob_entry( ptr ), "object", 5, 0 );
    if ( svp == NULL )
	croak( "Perl Lua::API::get_Perl_object: error getting object\n" );

    return *svp;
}

static
void set_Perl_object( void *ptr, SV* object )
{
    HV* oob = get_oob_entry( ptr );

    /* store Perl Lua::API::State object keyed off of lua_State pointer */
    SV** svp = hv_fetch( oob, "object", 5, 1 );

    if ( svp == NULL )
	croak( "Perl Lua::API::set_Perl_object: error getting object\n" );

    sv_setsv( *svp, object );
}

#if 0

/*-------------------------------------------------------------------*/
/* panic function to catch errors thrown from Lua API calls.  This is
   used to turn them into Perl exceptions */

static
int set_panic( lua_State *L, jump_buf *env)
{
    HV* oob = get_oob_entry( L );
    SV** svp = hv_fetch(oob, "panic", 5, 1 );

    if ( svp == NULL )
	croak( "Perl Lua::API: error getting panic state\n" );

    if ( env )
    {
	sv_setpvn( *svp, env, sizeof(*env) );
    }

    else
    {
	hv_delete( oob, "panic", 4, G_DISCARD );
    }
}

static
int panic( Lua_State *L )
{
    HV* oob = get_oob_entry( L );
    SV** svp = hv_fetch(oob, "panic", 5, 1 );

    if ( svp == NULL )
	croak( "Perl Lua::API: error getting panic state\n" );



}
#endif

/*-------------------------------------------------------------------*/
/* Support for hooks */


static
void set_hook( lua_State *L, SV* func )
{
    HV* oob = get_oob_entry( L );
    SV** svp = hv_fetch( oob, "hook", 4, 1 );

    if ( svp == NULL )
	croak( "Perl Lua::API: error getting hook\n" );

    if ( SvOK(func) )
    {
	sv_setsv( *svp, func );
    }

    else
    {
	hv_delete( oob, "hook", 4, G_DISCARD );
    }
}

/* trampoline */
static
void l2p_hook( lua_State *L, lua_Debug *ar )
{
    char *error = NULL;
    STRLEN error_len;
    SV** svp;
    HV* oob = get_oob_entry( L );
    SV* hook;
    dSP;

    svp = hv_fetch( oob, "hook", 4, 0 );
    if ( svp == NULL )
	croak( "Perl Lua::API: error getting hook\n" );
    hook = *svp;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);

    XPUSHs(get_Perl_object(L));
    XPUSHs(get_Perl_object(ar));

    PUTBACK;

    call_sv( hook, G_EVAL | G_DISCARD );

    SPAGAIN;

    /* catch exceptions */
    if (SvTRUE(ERRSV))
    {
       POPs;

       error = SvPV( ERRSV, error_len );
       /* If this is an exception thrown by Lua::API::State::error(),
          everything is already on the Lua stack and nothing further
          needs to be done.  If not, need to set up stack.
        */
       if ( ! sv_isa( ERRSV, "Lua::API::State::Error" ) )
	  lua_pushstring( L, error );
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    if ( error )
       lua_error( L );
}


/*-------------------------------------------------------------------*/
/* Support for pushcfunction and pushcclosure.
 *
 * The SV pointer is stored as the *last* upvalue for the trampoline
 * routine.  Perl routines which use lua_Debug.nups to get the number
 * of upvalues must decrement it by one to get their true upvalue
 * count.
 *
 */

static
int l2p_closure( lua_State *L )
{
    dSP;
    SV *func;
    char *error = NULL;
    STRLEN error_len;
    int count;
    lua_Debug ar;

    lua_getstack( L, 0, &ar );

    lua_getinfo( L, "u", &ar );

    func = (SV*) lua_touserdata( L, lua_upvalueindex( ar.nups ) );

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);

    XPUSHs(get_Perl_object(L));

    PUTBACK;

    count = call_sv( func, G_EVAL | G_SCALAR);

    /* catch exceptions */
    if (SvTRUE(ERRSV))
    {
       POPs;

       error = SvPV( ERRSV, error_len );
       /* If this is an exception thrown by Lua::API::State::error(),
          everything is already on the Lua stack and nothing further
          needs to be done.  If not, need to set up stack.
        */
       if ( ! sv_isa( ERRSV, "Lua::API::State::Error" ) )
	  lua_pushstring( L, error );
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    if ( error )
       lua_error( L );


    return count;
}

/*-------------------------------------------------------------------*/
/* Support for lua_cpcall.
 *
 * lua_cpcall calls a C function directly with a lightuserdata value
 * on the stack. We can't use a closure to wrap the Perl SV, so, we
 * wrap it explicitly in a structure.  This is the trampoline routine
 * which unwraps it and calls the Perl routine
 *
 */

typedef struct {
    SV *sv;    /* Perl function to call */
    void *ud;  /* user data pointer */
} CPCallData;

static
int l2p_cpcall( lua_State *L ) {
    dSP;
    int count;
    char *error = NULL;
    STRLEN error_len;
    CPCallData *data;


    /* grab our structure... */
    data = (CPCallData *) lua_touserdata( L, -1 );

    /* ...remove it from the stack */
    lua_pop( L, 1 );

    /* ...and replace it with the user data */
    lua_pushlightuserdata( L, data->ud );

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);

    XPUSHs(get_Perl_object(L));
    PUTBACK;

    count = call_sv( (SV*) data->sv, G_EVAL | G_DISCARD);

    SPAGAIN;

    /* catch exceptions */
    if (SvTRUE(ERRSV))
    {
       POPs;

       error = SvPV( ERRSV, error_len );
       /* If this is an exception thrown by Lua::API::State::error(),
          everything is already on the Lua stack and nothing further
          needs to be done.  If not, need to set up stack.
        */
       if ( ! sv_isa( ERRSV, "Lua::API::State::Error" ) )
	  lua_pushstring( L, error );
    }


    PUTBACK;
    FREETMPS;
    LEAVE;

    if ( error )
       lua_error( L );

    return count;
}

/*-------------------------------------------------------------------*/

/* put Lua error object on stack using lua_error. call only from XS
routines.  */

static int
call_lua_error( lua_State *L )
{
  return lua_error( L );
}

static void
throw_lua_error( lua_State *L, char *error )
{
   lua_pushcfunction( L, &call_lua_error );
   lua_pushstring(L, error );
   lua_pcall( L, 1, 0, 0 ); 
}

/* based on code in lauxlib.c */
static void
throw_luaL_error( lua_State *L, const char *fmt, ... )
{
   lua_pushcfunction( L, &call_lua_error );
   va_list argp;
   va_start(argp, fmt);
   luaL_where(L, 1);
   lua_pushvfstring(L, fmt, argp);
   va_end(argp);
   lua_concat(L, 2);
   lua_pcall( L, 1, 0, 0 ); 
}


/*-------------------------------------------------------------------*/


#include "wrap.h"


/*-------------------------------------------------------------------*/

#line 429 "API.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 573 "API.c"

/* INCLUDE:  Including 'const-xs.inc' from 'API.xs' */


XS_EUPXS(XS_Lua__API_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 598 "API.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Lua::API macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Lua::API macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Lua::API macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 676 "API.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'API.xs' from 'const-xs.inc' */


XS_EUPXS(XS_Lua__API_RELEASE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API_RELEASE)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 434 "API.xs"
        RETVAL = LUA_RELEASE;
#line 697 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API_COPYRIGHT); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API_COPYRIGHT)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 441 "API.xs"
        RETVAL = LUA_COPYRIGHT;
#line 715 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_atpanic); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_atpanic)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, panicf");
    {
	lua_State *	L;
	lua_CFunction	panicf;
	lua_CFunction	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::atpanic",
                        "L", "Lua::API::State")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "lua_CFunction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    panicf = INT2PTR(lua_CFunction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Lua::API::State::atpanic",
			"panicf", "lua_CFunction")
;

	RETVAL = lua_atpanic(L, panicf);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "lua_CFunction", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_call); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_call)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, nargs, nresults");
    {
	lua_State *	L;
	int	nargs = (int)SvIV(ST(1))
;
	int	nresults = (int)SvIV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::call",
                        "L", "Lua::API::State")
;

	lua_call(L, nargs, nresults);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_checkstack); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkstack)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "L, sz, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	lua_State *	L;
	int	sz = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkstack",
                        "L", "Lua::API::State")
;
#line 465 "API.xs"
	  /* call lua_checkstack */
	  if ( items == 2 )
	  {
	    int status = lua_checkstack( L, sz );
            EXTEND(SP, 1);
            PUSHs(sv_2mortal(newSViv(status)));
	  }
	  /* emulate luaL_checkstack */
	  else if ( items == 3 )
	  {
	    const char *msg = (const char*) SvPV_nolen(ST(2));
	    if ( !lua_checkstack( L, sz ) )
	    {
	       throw_luaL_error( L, "stack overflow (%s)", msg );
	       SV *rv = newSV(0);
	       SV *sv = newSVrv( rv, "Lua::API::State::Error" );
	       sv_setsv((SV*) get_sv("@", GV_ADD), rv);
	       croak(NULL);
	    }
	  }
	  else
	  {
	    croak_xs_usage( cv, "L,sz,[msg]" );
	  }
#line 841 "API.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lua__API__State_concat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_concat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, n");
    {
	lua_State *	L;
	int	n = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::concat",
                        "L", "Lua::API::State")
;

	lua_concat(L, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_cpcall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_cpcall)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, func, ud");
    {
	lua_State *	L;
	SV *	func = ST(1)
;
	SV *	ud = ST(2)
;
#line 506 "API.xs"
	CPCallData data = { func, ud };
#line 889 "API.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::cpcall",
                        "L", "Lua::API::State")
;
#line 508 "API.xs"
	RETVAL = lua_cpcall( L, l2p_cpcall, &data );
#line 904 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_createtable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_createtable)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narr, nrec");
    {
	lua_State *	L;
	int	narr = (int)SvIV(ST(1))
;
	int	nrec = (int)SvIV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::createtable",
                        "L", "Lua::API::State")
;

	lua_createtable(L, narr, nrec);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_equal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_equal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx1, idx2");
    {
	lua_State *	L;
	int	idx1 = (int)SvIV(ST(1))
;
	int	idx2 = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::equal",
                        "L", "Lua::API::State")
;

	RETVAL = lua_equal(L, idx1, idx2);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_gc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, what, data");
    {
	lua_State *	L;
	int	what = (int)SvIV(ST(1))
;
	int	data = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gc",
                        "L", "Lua::API::State")
;

	RETVAL = lua_gc(L, what, data);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getallocf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getallocf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, ud");
    {
	lua_State *	L;
	void **	ud;
	lua_Alloc	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getallocf",
                        "L", "Lua::API::State")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "voidPtrPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ud = INT2PTR(void **,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Lua::API::State::getallocf",
			"ud", "voidPtrPtr")
;

	RETVAL = lua_getallocf(L, ud);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "lua_Alloc", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getfenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getfenv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getfenv",
                        "L", "Lua::API::State")
;

	lua_getfenv(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_getfield); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getfield)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx, k");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	const char *	k = (const char *)SvPV_nolen(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getfield",
                        "L", "Lua::API::State")
;

	lua_getfield(L, idx, k);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_getgccount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getgccount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getgccount",
                        "L", "Lua::API::State")
;

	RETVAL = lua_getgccount(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getglobal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getglobal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, name");
    {
	lua_State *	L;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getglobal",
                        "L", "Lua::API::State")
;

	lua_getglobal(L, name);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_gethook); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gethook)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	lua_Hook	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gethook",
                        "L", "Lua::API::State")
;

	RETVAL = lua_gethook(L);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "lua_Hook", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_gethookcount); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gethookcount)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gethookcount",
                        "L", "Lua::API::State")
;

	RETVAL = lua_gethookcount(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_gethookmask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gethookmask)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gethookmask",
                        "L", "Lua::API::State")
;

	RETVAL = lua_gethookmask(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getinfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getinfo)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, what, ar");
    {
	lua_State *	L;
	const char *	what = (const char *)SvPV_nolen(ST(1))
;
	lua_Debug *	ar;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getinfo",
                        "L", "Lua::API::State")
;

        if (sv_derived_from(ST(2), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(2)));
            ar = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getinfo",
                        "ar", "Lua::API::Debug")
;

	RETVAL = lua_getinfo(L, what, ar);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getlocal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getlocal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, ar, n");
    {
	lua_State *	L;
	const lua_Debug *	ar;
	int	n = (int)SvIV(ST(2))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getlocal",
                        "L", "Lua::API::State")
;

        if (sv_derived_from(ST(1), "const Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            ar = INT2PTR(const lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getlocal",
                        "ar", "const Lua::API::Debug")
;

	RETVAL = lua_getlocal(L, ar, n);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getmetatable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getmetatable)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "L, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	lua_State *	L;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getmetatable",
                        "L", "Lua::API::State")
;
#line 592 "API.xs"
	if ( items != 1 )
	    croak_xs_usage( cv, "L,(objindex|name)" );
	if ( looks_like_number( ST(1) ) )
	{
	    int	objindex = (int)SvIV(ST(1));
	    int RETVAL = lua_getmetatable(L, objindex);
	    EXTEND(SP,1);
	    PUSHs(sv_2mortal(newSViv(RETVAL)));
	}
        else
	{
	    const char *n = (const char *)SvPV_nolen(ST(1));
	    luaL_getmetatable(L, n);
	    XSRETURN_EMPTY;
	}
#line 1364 "API.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lua__API__State_getregistry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getregistry)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getregistry",
                        "L", "Lua::API::State")
;

	lua_getregistry(L);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_getstack); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getstack)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, level, ar");
    {
	lua_State *	L;
	int	level = (int)SvIV(ST(1))
;
	lua_Debug *	ar;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getstack",
                        "L", "Lua::API::State")
;

        if (sv_derived_from(ST(2), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(2)));
            ar = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getstack",
                        "ar", "Lua::API::Debug")
;

	RETVAL = lua_getstack(L, level, ar);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_gettable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gettable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gettable",
                        "L", "Lua::API::State")
;

	lua_gettable(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_gettop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gettop)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gettop",
                        "L", "Lua::API::State")
;

	RETVAL = lua_gettop(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getupvalue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getupvalue)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, funcindex, n");
    {
	lua_State *	L;
	int	funcindex = (int)SvIV(ST(1))
;
	int	n = (int)SvIV(ST(2))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getupvalue",
                        "L", "Lua::API::State")
;

	RETVAL = lua_getupvalue(L, funcindex, n);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_insert); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_insert)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::insert",
                        "L", "Lua::API::State")
;

	lua_insert(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_isboolean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isboolean)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isboolean",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isboolean(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_iscfunction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_iscfunction)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::iscfunction",
                        "L", "Lua::API::State")
;

	RETVAL = lua_iscfunction(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isfunction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isfunction)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isfunction",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isfunction(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_islightuserdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_islightuserdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::islightuserdata",
                        "L", "Lua::API::State")
;

	RETVAL = lua_islightuserdata(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isnil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isnil)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isnil",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isnil(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isnone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isnone)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isnone",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isnone(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isnoneornil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isnoneornil)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isnoneornil",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isnoneornil(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isnumber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isnumber)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isnumber",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isnumber(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isstring",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isstring(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_istable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_istable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::istable",
                        "L", "Lua::API::State")
;

	RETVAL = lua_istable(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isthread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isthread)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isthread",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isthread(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_isuserdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_isuserdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::isuserdata",
                        "L", "Lua::API::State")
;

	RETVAL = lua_isuserdata(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_lessthan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_lessthan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx1, idx2");
    {
	lua_State *	L;
	int	idx1 = (int)SvIV(ST(1))
;
	int	idx2 = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::lessthan",
                        "L", "Lua::API::State")
;

	RETVAL = lua_lessthan(L, idx1, idx2);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_newtable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_newtable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::newtable",
                        "L", "Lua::API::State")
;

	lua_newtable(L);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_newthread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_newthread)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	lua_State *	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::newthread",
                        "L", "Lua::API::State")
;

	RETVAL = lua_newthread(L);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_iv(RETVALSV, "Lua::API::State", PTR2IV(RETVAL));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_newuserdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_newuserdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, sz");
    {
	lua_State *	L;
	size_t	sz = (size_t)SvUV(ST(1))
;
	void *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::newuserdata",
                        "L", "Lua::API::State")
;

	RETVAL = lua_newuserdata(L, sz);
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_next); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_next)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::next",
                        "L", "Lua::API::State")
;

	RETVAL = lua_next(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_objlen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_objlen)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	size_t	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::objlen",
                        "L", "Lua::API::State")
;

	RETVAL = lua_objlen(L, idx);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_pcall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pcall)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, nargs, nresults, errfunc");
    {
	lua_State *	L;
	int	nargs = (int)SvIV(ST(1))
;
	int	nresults = (int)SvIV(ST(2))
;
	int	errfunc = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pcall",
                        "L", "Lua::API::State")
;

	RETVAL = lua_pcall(L, nargs, nresults, errfunc);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_pop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pop)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pop",
                        "L", "Lua::API::State")
;

	lua_pop(L, index);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushboolean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushboolean)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, b");
    {
	lua_State *	L;
	int	b = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushboolean",
                        "L", "Lua::API::State")
;

	lua_pushboolean(L, b);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushcclosure); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushcclosure)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, fn, n");
    {
	lua_State *	L;
	SV *	fn = ST(1)
;
	int	n = (int)SvIV(ST(2))
;
#line 771 "API.xs"
	SV *sv_c = newSVsv(fn);
#line 2192 "API.c"

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushcclosure",
                        "L", "Lua::API::State")
;
#line 773 "API.xs"
        lua_pushlightuserdata(L, sv_c );
        lua_pushcclosure(L, l2p_closure, n+1 );
#line 2206 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushcfunction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushcfunction)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, f");
    {
	lua_State *	L;
	SV *	f = ST(1)
;
#line 781 "API.xs"
	SV *sv_c = newSVsv(f);
#line 2224 "API.c"

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushcfunction",
                        "L", "Lua::API::State")
;
#line 783 "API.xs"
        lua_pushlightuserdata(L, sv_c );
        lua_pushcclosure(L, l2p_closure, 1 );
#line 2238 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushinteger); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushinteger)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, n");
    {
	lua_State *	L;
	lua_Integer	n = (lua_Integer)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushinteger",
                        "L", "Lua::API::State")
;

	lua_pushinteger(L, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushlightuserdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushlightuserdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, p");
    {
	lua_State *	L;
	void *	p = INT2PTR(void *,SvIV(ST(1)))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushlightuserdata",
                        "L", "Lua::API::State")
;

	lua_pushlightuserdata(L, p);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushlstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushlstring)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, s, l");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;
	size_t	l = (size_t)SvUV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushlstring",
                        "L", "Lua::API::State")
;

	lua_pushlstring(L, s, l);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushliteral); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushliteral)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, s");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushliteral",
                        "L", "Lua::API::State")
;
#line 814 "API.xs"
         lua_pushlstring(L,s,strlen(s));
#line 2349 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushnil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushnil)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushnil",
                        "L", "Lua::API::State")
;

	lua_pushnil(L);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushnumber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushnumber)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, n");
    {
	lua_State *	L;
	lua_Number	n = (double)SvNV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushnumber",
                        "L", "Lua::API::State")
;

	lua_pushnumber(L, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, s");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushstring",
                        "L", "Lua::API::State")
;

	lua_pushstring(L, s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_pushthread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushthread)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushthread",
                        "L", "Lua::API::State")
;

	RETVAL = lua_pushthread(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_pushvalue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_pushvalue)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::pushvalue",
                        "L", "Lua::API::State")
;

	lua_pushvalue(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_rawequal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_rawequal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx1, idx2");
    {
	lua_State *	L;
	int	idx1 = (int)SvIV(ST(1))
;
	int	idx2 = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::rawequal",
                        "L", "Lua::API::State")
;

	RETVAL = lua_rawequal(L, idx1, idx2);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_rawget); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_rawget)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::rawget",
                        "L", "Lua::API::State")
;

	lua_rawget(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_rawgeti); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_rawgeti)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx, n");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	n = (int)SvIV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::rawgeti",
                        "L", "Lua::API::State")
;

	lua_rawgeti(L, idx, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_rawset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_rawset)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::rawset",
                        "L", "Lua::API::State")
;

	lua_rawset(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_rawseti); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_rawseti)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx, n");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	n = (int)SvIV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::rawseti",
                        "L", "Lua::API::State")
;

	lua_rawseti(L, idx, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::remove",
                        "L", "Lua::API::State")
;

	lua_remove(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_replace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_replace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::replace",
                        "L", "Lua::API::State")
;

	lua_replace(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_resume)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::resume",
                        "L", "Lua::API::State")
;

	RETVAL = lua_resume(L, narg);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_setfenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setfenv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setfenv",
                        "L", "Lua::API::State")
;

	RETVAL = lua_setfenv(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_setfield); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setfield)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx, k");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	const char *	k = (const char *)SvPV_nolen(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setfield",
                        "L", "Lua::API::State")
;

	lua_setfield(L, idx, k);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_setglobal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setglobal)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, s");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setglobal",
                        "L", "Lua::API::State")
;

	lua_setglobal(L, s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_sethook); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_sethook)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, func, mask, count");
    {
	lua_State *	L;
	SV *	func = ST(1)
;
	int	mask = (int)SvIV(ST(2))
;
	int	count = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::sethook",
                        "L", "Lua::API::State")
;
#line 921 "API.xs"
        set_hook( L, func );
	RETVAL = lua_sethook( L, SvOK(func) ? l2p_hook : NULL, mask, count );
#line 2832 "API.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_setlevel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setlevel)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "from, to");
    {
	lua_State *	from;
	lua_State *	to;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            from = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setlevel",
                        "from", "Lua::API::State")
;

        if (sv_derived_from(ST(1), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            to = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setlevel",
                        "to", "Lua::API::State")
;

	lua_setlevel(from, to);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_setlocal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setlocal)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, ar, n");
    {
	lua_State *	L;
	const lua_Debug *	ar;
	int	n = (int)SvIV(ST(2))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setlocal",
                        "L", "Lua::API::State")
;

        if (sv_derived_from(ST(1), "const Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            ar = INT2PTR(const lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setlocal",
                        "ar", "const Lua::API::Debug")
;

	RETVAL = lua_setlocal(L, ar, n);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_setmetatable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setmetatable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, objindex");
    {
	lua_State *	L;
	int	objindex = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setmetatable",
                        "L", "Lua::API::State")
;

	RETVAL = lua_setmetatable(L, objindex);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_settable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_settable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::settable",
                        "L", "Lua::API::State")
;

	lua_settable(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_settop); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_settop)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::settop",
                        "L", "Lua::API::State")
;

	lua_settop(L, idx);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_setupvalue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_setupvalue)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, funcindex, n");
    {
	lua_State *	L;
	int	funcindex = (int)SvIV(ST(1))
;
	int	n = (int)SvIV(ST(2))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::setupvalue",
                        "L", "Lua::API::State")
;

	RETVAL = lua_setupvalue(L, funcindex, n);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::status",
                        "L", "Lua::API::State")
;

	RETVAL = lua_status(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_strlen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_strlen)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	size_t	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::strlen",
                        "L", "Lua::API::State")
;

	RETVAL = lua_strlen(L, index);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_toboolean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_toboolean)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::toboolean",
                        "L", "Lua::API::State")
;

	RETVAL = lua_toboolean(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_tocfunction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_tocfunction)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	lua_CFunction	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::tocfunction",
                        "L", "Lua::API::State")
;

	RETVAL = lua_tocfunction(L, idx);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "lua_CFunction", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_tointeger); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_tointeger)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	lua_Integer	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::tointeger",
                        "L", "Lua::API::State")
;

	RETVAL = lua_tointeger(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_tolstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_tolstring)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, idx, len");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	size_t	len = (size_t)SvUV(ST(2))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::tolstring",
                        "L", "Lua::API::State")
;

	RETVAL = lua_tolstring(L, idx, &len);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_tonumber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_tonumber)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	lua_Number	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::tonumber",
                        "L", "Lua::API::State")
;

	RETVAL = lua_tonumber(L, idx);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_topointer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_topointer)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	const void *	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::topointer",
                        "L", "Lua::API::State")
;

	RETVAL = lua_topointer(L, idx);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "const voidPtr", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_tostring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_tostring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::tostring",
                        "L", "Lua::API::State")
;

	RETVAL = lua_tostring(L, index);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_tothread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_tothread)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	lua_State *	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::tothread",
                        "L", "Lua::API::State")
;

	RETVAL = lua_tothread(L, idx);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_iv(RETVALSV, "Lua::API::State", PTR2IV(RETVAL));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_touserdata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_touserdata)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	SV *	RETVAL;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::touserdata",
                        "L", "Lua::API::State")
;

	RETVAL = lua_touserdata(L, idx);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_type)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, idx");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::type",
                        "L", "Lua::API::State")
;

	RETVAL = lua_type(L, idx);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_typename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_typename)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, tp");
    {
	lua_State *	L;
	int	tp = (int)SvIV(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::typename",
                        "L", "Lua::API::State")
;

	RETVAL = lua_typename(L, tp);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_xmove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_xmove)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "from, to, n");
    {
	lua_State *	from;
	lua_State *	to;
	int	n = (int)SvIV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            from = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::xmove",
                        "from", "Lua::API::State")
;

        if (sv_derived_from(ST(1), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            to = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::xmove",
                        "to", "Lua::API::State")
;

	lua_xmove(from, to, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_yield); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_yield)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, nresults");
    {
	lua_State *	L;
	int	nresults = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::yield",
                        "L", "Lua::API::State")
;

	RETVAL = lua_yield(L, nresults);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_base); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_base)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_base",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_base(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_debug)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_debug",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_debug(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_io); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_io)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_io",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_io(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_math); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_math)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_math",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_math(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_os); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_os)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_os",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_os(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_package); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_package)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_package",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_package(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_string",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_string(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaopen_table); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaopen_table)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaopen_table",
                        "L", "Lua::API::State")
;

	RETVAL = luaopen_table(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE:  Including 'xs.h' from 'API.xs' */


XS_EUPXS(XS_Lua__API__State_checklong); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checklong)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
#line 6 "./xs.h"
        int stacklen;
	int stackpos;
/* long luaL_checklong (lua_State *L, int narg); */
        checklong_S data;
	data.narg = narg;
#line 3744 "API.c"
	long	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checklong",
                        "L", "Lua::API::State")
;
#line 12 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checklong: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checklong );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 3782 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checktype); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checktype)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, t");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	int	t = (int)SvIV(ST(2))
;
#line 45 "./xs.h"
        int stacklen;
	int stackpos;
/* void luaL_checktype (lua_State *L, int narg, int t); */
        checktype_S data;
	data.narg = narg;
	data.t = t;
#line 3808 "API.c"

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checktype",
                        "L", "Lua::API::State")
;
#line 52 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checktype: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checktype );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }
#line 3839 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_checkany); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkany)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
#line 77 "./xs.h"
        int stacklen;
	int stackpos;
/* void luaL_checkany (lua_State *L, int narg); */
        checkany_S data;
	data.narg = narg;
#line 3861 "API.c"

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkany",
                        "L", "Lua::API::State")
;
#line 83 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checkany: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checkany );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }
#line 3892 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_argcheck); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_argcheck)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, cond, narg, extramsg");
    {
	lua_State *	L;
	int	cond = (int)SvIV(ST(1))
;
	int	narg = (int)SvIV(ST(2))
;
	const char *	extramsg = (const char *)SvPV_nolen(ST(3))
;
#line 110 "./xs.h"
        int stacklen;
	int stackpos;
/* void luaL_argcheck (lua_State *L, int cond, int narg, const char *extramsg); */
        argcheck_S data;
	data.cond = cond;
	data.narg = narg;
	data.extramsg = extramsg;
#line 3920 "API.c"

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::argcheck",
                        "L", "Lua::API::State")
;
#line 118 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_argcheck: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_argcheck );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }
#line 3951 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_checkint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkint)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
#line 143 "./xs.h"
        int stacklen;
	int stackpos;
/* int luaL_checkint (lua_State *L, int narg); */
        checkint_S data;
	data.narg = narg;
#line 3973 "API.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkint",
                        "L", "Lua::API::State")
;
#line 149 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checkint: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checkint );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4011 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_argerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_argerror)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, extramsg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	const char *	extramsg = (const char *)SvPV_nolen(ST(2))
;
#line 182 "./xs.h"
        int stacklen;
	int stackpos;
/* int luaL_argerror (lua_State *L, int narg, const char *extramsg); */
        argerror_S data;
	data.narg = narg;
	data.extramsg = extramsg;
#line 4037 "API.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::argerror",
                        "L", "Lua::API::State")
;
#line 189 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_argerror: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_argerror );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4075 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_optinteger); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_optinteger)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, d");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	lua_Integer	d = (lua_Integer)SvIV(ST(2))
;
#line 222 "./xs.h"
        int stacklen;
	int stackpos;
/* lua_Integer luaL_optinteger (lua_State *L, int narg, lua_Integer d); */
        optinteger_S data;
	data.narg = narg;
	data.d = d;
#line 4101 "API.c"
	lua_Integer	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::optinteger",
                        "L", "Lua::API::State")
;
#line 229 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_optinteger: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_optinteger );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4139 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checklstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checklstring)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, l");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	size_t	l;
#line 262 "./xs.h"
        int stacklen;
	int stackpos;
/* const char *luaL_checklstring (lua_State *L, int narg, size_t *l); */
        checklstring_S data;
	data.narg = narg;
	data.l = &l;
#line 4164 "API.c"
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checklstring",
                        "L", "Lua::API::State")
;
#line 269 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checklstring: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checklstring );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4202 "API.c"
	sv_setuv(ST(2), (UV)l);
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checkoption); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkoption)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, narg, def, lst");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	const char *	def = (const char *)SvPV_nolen(ST(2))
;
	const char * const *	lst = (const char * const *)SvPV_nolen(ST(3))
;
#line 304 "./xs.h"
        int stacklen;
	int stackpos;
/* int luaL_checkoption (lua_State *L, int narg, const char *def, const char *const lst[]); */
        checkoption_S data;
	data.narg = narg;
	data.def = def;
	data.lst = lst;
#line 4233 "API.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkoption",
                        "L", "Lua::API::State")
;
#line 312 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checkoption: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checkoption );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4271 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_optint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_optint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, d");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	int	d = (int)SvIV(ST(2))
;
#line 345 "./xs.h"
        int stacklen;
	int stackpos;
/* int luaL_optint (lua_State *L, int narg, int d); */
        optint_S data;
	data.narg = narg;
	data.d = d;
#line 4297 "API.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::optint",
                        "L", "Lua::API::State")
;
#line 352 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_optint: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_optint );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4335 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checkudata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkudata)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, tname");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	const char *	tname = (const char *)SvPV_nolen(ST(2))
;
#line 385 "./xs.h"
        int stacklen;
	int stackpos;
/* void *luaL_checkudata (lua_State *L, int narg, const char *tname); */
        checkudata_S data;
	data.narg = narg;
	data.tname = tname;
#line 4361 "API.c"
	void *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkudata",
                        "L", "Lua::API::State")
;
#line 392 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checkudata: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checkudata );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4399 "API.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checkstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
#line 424 "./xs.h"
        int stacklen;
	int stackpos;
/* const char *luaL_checkstring (lua_State *L, int narg); */
        checkstring_S data;
	data.narg = narg;
#line 4422 "API.c"
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkstring",
                        "L", "Lua::API::State")
;
#line 430 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checkstring: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checkstring );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4460 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_optlong); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_optlong)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, d");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	long	d = (long)SvIV(ST(2))
;
#line 463 "./xs.h"
        int stacklen;
	int stackpos;
/* long luaL_optlong (lua_State *L, int narg, long d); */
        optlong_S data;
	data.narg = narg;
	data.d = d;
#line 4486 "API.c"
	long	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::optlong",
                        "L", "Lua::API::State")
;
#line 470 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_optlong: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_optlong );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4524 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_optlstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_optlstring)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, narg, d, l");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	const char *	d = (const char *)SvPV_nolen(ST(2))
;
	size_t	l;
#line 504 "./xs.h"
        int stacklen;
	int stackpos;
/* const char *luaL_optlstring (lua_State *L, int narg, const char *d, size_t *l); */
        optlstring_S data;
	data.narg = narg;
	data.d = d;
	data.l = &l;
#line 4552 "API.c"
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::optlstring",
                        "L", "Lua::API::State")
;
#line 512 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_optlstring: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_optlstring );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4590 "API.c"
	sv_setuv(ST(3), (UV)l);
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checknumber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checknumber)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
#line 545 "./xs.h"
        int stacklen;
	int stackpos;
/* lua_Number luaL_checknumber (lua_State *L, int narg); */
        checknumber_S data;
	data.narg = narg;
#line 4615 "API.c"
	lua_Number	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checknumber",
                        "L", "Lua::API::State")
;
#line 551 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checknumber: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checknumber );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4653 "API.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_typerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_typerror)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, tname");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	const char *	tname = (const char *)SvPV_nolen(ST(2))
;
#line 584 "./xs.h"
        int stacklen;
	int stackpos;
/* int luaL_typerror (lua_State *L, int narg, const char *tname);
 */
        typerror_S data;
	data.narg = narg;
	data.tname = tname;
#line 4680 "API.c"
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::typerror",
                        "L", "Lua::API::State")
;
#line 592 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_typerror: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_typerror );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4718 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_optstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_optstring)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, d");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	const char *	d = (const char *)SvPV_nolen(ST(2))
;
#line 625 "./xs.h"
        int stacklen;
	int stackpos;
/* const char *luaL_optstring (lua_State *L, int narg, const char *d); */
        optstring_S data;
	data.narg = narg;
	data.d = d;
#line 4744 "API.c"
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::optstring",
                        "L", "Lua::API::State")
;
#line 632 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_optstring: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_optstring );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4782 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_checkinteger); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_checkinteger)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, narg");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
#line 664 "./xs.h"
        int stacklen;
	int stackpos;
/* lua_Integer luaL_checkinteger (lua_State *L, int narg); */
        checkinteger_S data;
	data.narg = narg;
#line 4805 "API.c"
	lua_Integer	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::checkinteger",
                        "L", "Lua::API::State")
;
#line 670 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_checkinteger: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_checkinteger );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4843 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_optnumber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_optnumber)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, narg, d");
    {
	lua_State *	L;
	int	narg = (int)SvIV(ST(1))
;
	lua_Number	d = (double)SvNV(ST(2))
;
#line 703 "./xs.h"
        int stacklen;
	int stackpos;
/* lua_Number luaL_optnumber (lua_State *L, int narg, lua_Number d); */
        optnumber_S data;
	data.narg = narg;
	data.d = d;
#line 4869 "API.c"
	lua_Number	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::optnumber",
                        "L", "Lua::API::State")
;
#line 710 "./xs.h"
         /* catch Lua error and transform it into a Perl one by
	   calling a C wrapper, duplicating the stack so that
	   it can be checked*/
        stacklen = lua_gettop( L );
	if ( ! lua_checkstack( L, stacklen + 2 ) )
            croak( "Perl Lua::API::wrap_optnumber: error extending stack\n" );
        /* push C wrapper */
        lua_pushcfunction(L, &wrap_optnumber );
	/* duplicate stack  */
	for( stackpos = 1 ; stackpos <= stacklen ; stackpos++ )
	   lua_pushvalue( L, stackpos );
	/* push struct containing the parameters */
	lua_pushlightuserdata( L, &data );
        if ( lua_pcall( L, stacklen+1, 0, 0 ) ) {
	  SV *rv = newSV(0);
	  SV *sv = newSVrv( rv, "Lua::API::State::Error" );
          sv_setsv((SV*) get_sv("@", GV_ADD), rv);
  	  croak(NULL);
        }

        /* no error; extract return value from call and pass it up */
        else {
          RETVAL = data.retval;
        }
#line 4907 "API.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'API.xs' from 'xs.h' */


XS_EUPXS(XS_Lua__API__State_openlibs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_openlibs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::openlibs",
                        "L", "Lua::API::State")
;

	luaL_openlibs(L);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_buffinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_buffinit)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, B");
    {
	lua_State *	L;
	luaL_Buffer *	B;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::buffinit",
                        "L", "Lua::API::State")
;

        if (sv_derived_from(ST(1), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::buffinit",
                        "B", "Lua::API::Buffer")
;

	luaL_buffinit(L, B);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_callmeta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_callmeta)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, obj, e");
    {
	lua_State *	L;
	int	obj = (int)SvIV(ST(1))
;
	const char *	e = (const char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::callmeta",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_callmeta(L, obj, e);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_dofile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_dofile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, fn");
    {
	lua_State *	L;
	const char *	fn = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::dofile",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_dofile(L, fn);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_dostring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_dostring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, s");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::dostring",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_dostring(L, s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_findtable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_findtable)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, idx, fname, szhint");
    {
	lua_State *	L;
	int	idx = (int)SvIV(ST(1))
;
	const char *	fname = (const char *)SvPV_nolen(ST(2))
;
	int	szhint = (int)SvIV(ST(3))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::findtable",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_findtable(L, idx, fname, szhint);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_getmetafield); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_getmetafield)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, obj, e");
    {
	lua_State *	L;
	int	obj = (int)SvIV(ST(1))
;
	const char *	e = (const char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::getmetafield",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_getmetafield(L, obj, e);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_gsub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_gsub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, s, p, r");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;
	const char *	p = (const char *)SvPV_nolen(ST(2))
;
	const char *	r = (const char *)SvPV_nolen(ST(3))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::gsub",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_gsub(L, s, p, r);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_loadbuffer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_loadbuffer)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "L, buff, sz, name");
    {
	lua_State *	L;
	const char *	buff = (const char *)SvPV_nolen(ST(1))
;
	size_t	sz = (size_t)SvUV(ST(2))
;
	const char *	name = (const char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::loadbuffer",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_loadbuffer(L, buff, sz, name);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_loadfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_loadfile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, filename");
    {
	lua_State *	L;
	const char *	filename = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::loadfile",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_loadfile(L, filename);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_loadstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_loadstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, s");
    {
	lua_State *	L;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::loadstring",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_loadstring(L, s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_newmetatable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_newmetatable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, tname");
    {
	lua_State *	L;
	const char *	tname = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::newmetatable",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_newmetatable(L, tname);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_newstate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_newstate)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	CLASS;
	lua_State *	RETVAL;
#line 1151 "API.xs"
        RETVAL = luaL_newstate();
	ST(0) = sv_newmortal();
        sv_setref_iv(ST(0), "Lua::API::State", PTR2IV(RETVAL));
	set_Perl_object( RETVAL, ST(0) );
        XSRETURN(1);
#line 5312 "API.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lua__API__State_ref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_ref)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, t");
    {
	lua_State *	L;
	int	t = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::ref",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_ref(L, t);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_unref); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_unref)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, t, ref");
    {
	lua_State *	L;
	int	t = (int)SvIV(ST(1))
;
	int	ref = (int)SvIV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::unref",
                        "L", "Lua::API::State")
;

	luaL_unref(L, t, ref);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_where); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_where)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, lvl");
    {
	lua_State *	L;
	int	lvl = (int)SvIV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::where",
                        "L", "Lua::API::State")
;

	luaL_where(L, lvl);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_DESTROY)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        GvNAME(CvGV(cv)),
                        "L", "Lua::API::State")
;
#line 1189 "API.xs"
 	if ( NULL != delete_oob_entry( L ) )
	    lua_close( L );
#line 5427 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_lua_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_lua_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "L");
    {
	lua_State *	L;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::lua_error",
                        "L", "Lua::API::State")
;

	RETVAL = lua_error(L);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_lua_register); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_lua_register)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "L, name, f");
    {
	lua_State *	L;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	SV *	f = ST(2)
;
#line 1206 "API.xs"
	SV *sv_c = newSVsv(f);
#line 5475 "API.c"

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::lua_register",
                        "L", "Lua::API::State")
;
#line 1208 "API.xs"
        lua_pushlightuserdata(L, sv_c );
        lua_pushcclosure(L, l2p_closure, 1 );
	lua_setglobal(L, name );
#line 5490 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_lua_getmetatable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_lua_getmetatable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, index");
    {
	lua_State *	L;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::lua_getmetatable",
                        "L", "Lua::API::State")
;

	RETVAL = lua_getmetatable(L, index);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaL_getmetatable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaL_getmetatable)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, n");
    {
	lua_State *	L;
	const char *	n = (const char *)SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaL_getmetatable",
                        "L", "Lua::API::State")
;

	luaL_getmetatable(L, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__State_lua_typename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_lua_typename)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, tp");
    {
	lua_State *	L;
	int	tp = (int)SvIV(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::lua_typename",
                        "L", "Lua::API::State")
;

	RETVAL = lua_typename(L, tp);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__State_luaL_typename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__State_luaL_typename)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "L, i");
    {
	lua_State *	L;
	int	i = (int)SvIV(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::State")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            L = INT2PTR(lua_State *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::State::luaL_typename",
                        "L", "Lua::API::State")
;

	RETVAL = luaL_typename(L, i);
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	CLASS;
	lua_Debug *	RETVAL;
#line 1239 "API.xs"
        Newxz( RETVAL, 1, lua_Debug );
	ST(0) = sv_newmortal();
        sv_setref_iv(ST(0), "Lua::API::Debug", PTR2IV(RETVAL));
	set_Perl_object( RETVAL, ST(0) );
        XSRETURN(1);
#line 5630 "API.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lua__API__Debug_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::DESTROY",
                        "THIS", "Lua::API::Debug")
;
#line 1249 "API.xs"
        delete_oob_entry( THIS );
        Safefree(THIS);
#line 5658 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Debug_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_event)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::event",
                        "THIS", "Lua::API::Debug")
;
#line 1257 "API.xs"
	RETVAL = THIS->event;
#line 5686 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::name",
                        "THIS", "Lua::API::Debug")
;
#line 1266 "API.xs"
	RETVAL = THIS->name;
#line 5715 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_namewhat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_namewhat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::namewhat",
                        "THIS", "Lua::API::Debug")
;
#line 1275 "API.xs"
	RETVAL = THIS->namewhat;
#line 5744 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_what); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_what)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::what",
                        "THIS", "Lua::API::Debug")
;
#line 1284 "API.xs"
	RETVAL = THIS->what;
#line 5773 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_source); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_source)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	const char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::source",
                        "THIS", "Lua::API::Debug")
;
#line 1293 "API.xs"
	RETVAL = THIS->source;
#line 5802 "API.c"
	XSprePUSH; PUSHp(RETVAL, RETVAL ? strlen(RETVAL) : 0 );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_currentline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_currentline)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::currentline",
                        "THIS", "Lua::API::Debug")
;
#line 1302 "API.xs"
	RETVAL = THIS->currentline;
#line 5831 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_nups); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_nups)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::nups",
                        "THIS", "Lua::API::Debug")
;
#line 1311 "API.xs"
	RETVAL = THIS->nups;
#line 5860 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_linedefined); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_linedefined)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::linedefined",
                        "THIS", "Lua::API::Debug")
;
#line 1320 "API.xs"
	RETVAL = THIS->linedefined;
#line 5889 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_lastlinedefined); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_lastlinedefined)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	int	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::lastlinedefined",
                        "THIS", "Lua::API::Debug")
;
#line 1329 "API.xs"
	RETVAL = THIS->lastlinedefined;
#line 5918 "API.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Debug_short_src); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Debug_short_src)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	lua_Debug *	THIS;
	char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Debug")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(lua_Debug *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Debug::short_src",
                        "THIS", "Lua::API::Debug")
;
#line 1338 "API.xs"
	RETVAL = THIS->short_src;
#line 5947 "API.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Buffer_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	CLASS;
	luaL_Buffer *	RETVAL;
#line 1349 "API.xs"
        Newxz( RETVAL, 1, luaL_Buffer );
	ST(0) = sv_newmortal();
        sv_setref_iv(ST(0), "Lua::API::Buffer", PTR2IV(RETVAL));
	set_Perl_object( RETVAL, ST(0) );
        XSRETURN(1);
#line 5971 "API.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Lua__API__Buffer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	luaL_Buffer *	THIS;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            THIS = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::DESTROY",
                        "THIS", "Lua::API::Buffer")
;
#line 1359 "API.xs"
        delete_oob_entry( THIS );
        Safefree(THIS);
#line 5999 "API.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Buffer_addchar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_addchar)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "B, c");
    {
	luaL_Buffer *	B;
	char	c = (char)*SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::addchar",
                        "B", "Lua::API::Buffer")
;

	luaL_addchar(B, c);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Buffer_addlstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_addlstring)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "B, s, l");
    {
	luaL_Buffer *	B;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;
	size_t	l = (size_t)SvUV(ST(2))
;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::addlstring",
                        "B", "Lua::API::Buffer")
;

	luaL_addlstring(B, s, l);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Buffer_addsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_addsize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "B, n");
    {
	luaL_Buffer *	B;
	size_t	n = (size_t)SvUV(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::addsize",
                        "B", "Lua::API::Buffer")
;

	luaL_addsize(B, n);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Buffer_addstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_addstring)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "B, s");
    {
	luaL_Buffer *	B;
	const char *	s = (const char *)SvPV_nolen(ST(1))
;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::addstring",
                        "B", "Lua::API::Buffer")
;

	luaL_addstring(B, s);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Buffer_addvalue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_addvalue)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "B");
    {
	luaL_Buffer *	B;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::addvalue",
                        "B", "Lua::API::Buffer")
;

	luaL_addvalue(B);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Lua__API__Buffer_prepbuffer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_prepbuffer)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "B");
    {
	luaL_Buffer *	B;
	char *	RETVAL;
	dXSTARG;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::prepbuffer",
                        "B", "Lua::API::Buffer")
;

	RETVAL = luaL_prepbuffer(B);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Lua__API__Buffer_pushresult); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Lua__API__Buffer_pushresult)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "B");
    {
	luaL_Buffer *	B;

        if (sv_derived_from(ST(0), "Lua::API::Buffer")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            B = INT2PTR(luaL_Buffer *,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Lua::API::Buffer::pushresult",
                        "B", "Lua::API::Buffer")
;

	luaL_pushresult(B);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Lua__API); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Lua__API)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Lua::API::constant", XS_Lua__API_constant);
        newXS_deffile("Lua::API::RELEASE", XS_Lua__API_RELEASE);
        newXS_deffile("Lua::API::COPYRIGHT", XS_Lua__API_COPYRIGHT);
        newXS_deffile("Lua::API::State::atpanic", XS_Lua__API__State_atpanic);
        newXS_deffile("Lua::API::State::call", XS_Lua__API__State_call);
        newXS_deffile("Lua::API::State::checkstack", XS_Lua__API__State_checkstack);
        newXS_deffile("Lua::API::State::concat", XS_Lua__API__State_concat);
        newXS_deffile("Lua::API::State::cpcall", XS_Lua__API__State_cpcall);
        newXS_deffile("Lua::API::State::createtable", XS_Lua__API__State_createtable);
        newXS_deffile("Lua::API::State::equal", XS_Lua__API__State_equal);
        newXS_deffile("Lua::API::State::gc", XS_Lua__API__State_gc);
        newXS_deffile("Lua::API::State::getallocf", XS_Lua__API__State_getallocf);
        newXS_deffile("Lua::API::State::getfenv", XS_Lua__API__State_getfenv);
        newXS_deffile("Lua::API::State::getfield", XS_Lua__API__State_getfield);
        newXS_deffile("Lua::API::State::getgccount", XS_Lua__API__State_getgccount);
        newXS_deffile("Lua::API::State::getglobal", XS_Lua__API__State_getglobal);
        newXS_deffile("Lua::API::State::gethook", XS_Lua__API__State_gethook);
        newXS_deffile("Lua::API::State::gethookcount", XS_Lua__API__State_gethookcount);
        newXS_deffile("Lua::API::State::gethookmask", XS_Lua__API__State_gethookmask);
        newXS_deffile("Lua::API::State::getinfo", XS_Lua__API__State_getinfo);
        newXS_deffile("Lua::API::State::getlocal", XS_Lua__API__State_getlocal);
        newXS_deffile("Lua::API::State::getmetatable", XS_Lua__API__State_getmetatable);
        newXS_deffile("Lua::API::State::getregistry", XS_Lua__API__State_getregistry);
        newXS_deffile("Lua::API::State::getstack", XS_Lua__API__State_getstack);
        newXS_deffile("Lua::API::State::gettable", XS_Lua__API__State_gettable);
        newXS_deffile("Lua::API::State::gettop", XS_Lua__API__State_gettop);
        newXS_deffile("Lua::API::State::getupvalue", XS_Lua__API__State_getupvalue);
        newXS_deffile("Lua::API::State::insert", XS_Lua__API__State_insert);
        newXS_deffile("Lua::API::State::isboolean", XS_Lua__API__State_isboolean);
        newXS_deffile("Lua::API::State::iscfunction", XS_Lua__API__State_iscfunction);
        newXS_deffile("Lua::API::State::isfunction", XS_Lua__API__State_isfunction);
        newXS_deffile("Lua::API::State::islightuserdata", XS_Lua__API__State_islightuserdata);
        newXS_deffile("Lua::API::State::isnil", XS_Lua__API__State_isnil);
        newXS_deffile("Lua::API::State::isnone", XS_Lua__API__State_isnone);
        newXS_deffile("Lua::API::State::isnoneornil", XS_Lua__API__State_isnoneornil);
        newXS_deffile("Lua::API::State::isnumber", XS_Lua__API__State_isnumber);
        newXS_deffile("Lua::API::State::isstring", XS_Lua__API__State_isstring);
        newXS_deffile("Lua::API::State::istable", XS_Lua__API__State_istable);
        newXS_deffile("Lua::API::State::isthread", XS_Lua__API__State_isthread);
        newXS_deffile("Lua::API::State::isuserdata", XS_Lua__API__State_isuserdata);
        newXS_deffile("Lua::API::State::lessthan", XS_Lua__API__State_lessthan);
        newXS_deffile("Lua::API::State::newtable", XS_Lua__API__State_newtable);
        newXS_deffile("Lua::API::State::newthread", XS_Lua__API__State_newthread);
        newXS_deffile("Lua::API::State::newuserdata", XS_Lua__API__State_newuserdata);
        newXS_deffile("Lua::API::State::next", XS_Lua__API__State_next);
        newXS_deffile("Lua::API::State::objlen", XS_Lua__API__State_objlen);
        newXS_deffile("Lua::API::State::pcall", XS_Lua__API__State_pcall);
        newXS_deffile("Lua::API::State::pop", XS_Lua__API__State_pop);
        newXS_deffile("Lua::API::State::pushboolean", XS_Lua__API__State_pushboolean);
        newXS_deffile("Lua::API::State::pushcclosure", XS_Lua__API__State_pushcclosure);
        newXS_deffile("Lua::API::State::pushcfunction", XS_Lua__API__State_pushcfunction);
        newXS_deffile("Lua::API::State::pushinteger", XS_Lua__API__State_pushinteger);
        newXS_deffile("Lua::API::State::pushlightuserdata", XS_Lua__API__State_pushlightuserdata);
        newXS_deffile("Lua::API::State::pushlstring", XS_Lua__API__State_pushlstring);
        newXS_deffile("Lua::API::State::pushliteral", XS_Lua__API__State_pushliteral);
        newXS_deffile("Lua::API::State::pushnil", XS_Lua__API__State_pushnil);
        newXS_deffile("Lua::API::State::pushnumber", XS_Lua__API__State_pushnumber);
        newXS_deffile("Lua::API::State::pushstring", XS_Lua__API__State_pushstring);
        newXS_deffile("Lua::API::State::pushthread", XS_Lua__API__State_pushthread);
        newXS_deffile("Lua::API::State::pushvalue", XS_Lua__API__State_pushvalue);
        newXS_deffile("Lua::API::State::rawequal", XS_Lua__API__State_rawequal);
        newXS_deffile("Lua::API::State::rawget", XS_Lua__API__State_rawget);
        newXS_deffile("Lua::API::State::rawgeti", XS_Lua__API__State_rawgeti);
        newXS_deffile("Lua::API::State::rawset", XS_Lua__API__State_rawset);
        newXS_deffile("Lua::API::State::rawseti", XS_Lua__API__State_rawseti);
        newXS_deffile("Lua::API::State::remove", XS_Lua__API__State_remove);
        newXS_deffile("Lua::API::State::replace", XS_Lua__API__State_replace);
        newXS_deffile("Lua::API::State::resume", XS_Lua__API__State_resume);
        newXS_deffile("Lua::API::State::setfenv", XS_Lua__API__State_setfenv);
        newXS_deffile("Lua::API::State::setfield", XS_Lua__API__State_setfield);
        newXS_deffile("Lua::API::State::setglobal", XS_Lua__API__State_setglobal);
        newXS_deffile("Lua::API::State::sethook", XS_Lua__API__State_sethook);
        newXS_deffile("Lua::API::State::setlevel", XS_Lua__API__State_setlevel);
        newXS_deffile("Lua::API::State::setlocal", XS_Lua__API__State_setlocal);
        newXS_deffile("Lua::API::State::setmetatable", XS_Lua__API__State_setmetatable);
        newXS_deffile("Lua::API::State::settable", XS_Lua__API__State_settable);
        newXS_deffile("Lua::API::State::settop", XS_Lua__API__State_settop);
        newXS_deffile("Lua::API::State::setupvalue", XS_Lua__API__State_setupvalue);
        newXS_deffile("Lua::API::State::status", XS_Lua__API__State_status);
        newXS_deffile("Lua::API::State::strlen", XS_Lua__API__State_strlen);
        newXS_deffile("Lua::API::State::toboolean", XS_Lua__API__State_toboolean);
        newXS_deffile("Lua::API::State::tocfunction", XS_Lua__API__State_tocfunction);
        newXS_deffile("Lua::API::State::tointeger", XS_Lua__API__State_tointeger);
        newXS_deffile("Lua::API::State::tolstring", XS_Lua__API__State_tolstring);
        newXS_deffile("Lua::API::State::tonumber", XS_Lua__API__State_tonumber);
        newXS_deffile("Lua::API::State::topointer", XS_Lua__API__State_topointer);
        newXS_deffile("Lua::API::State::tostring", XS_Lua__API__State_tostring);
        newXS_deffile("Lua::API::State::tothread", XS_Lua__API__State_tothread);
        newXS_deffile("Lua::API::State::touserdata", XS_Lua__API__State_touserdata);
        newXS_deffile("Lua::API::State::type", XS_Lua__API__State_type);
        newXS_deffile("Lua::API::State::typename", XS_Lua__API__State_typename);
        newXS_deffile("Lua::API::State::xmove", XS_Lua__API__State_xmove);
        newXS_deffile("Lua::API::State::yield", XS_Lua__API__State_yield);
        newXS_deffile("Lua::API::State::luaopen_base", XS_Lua__API__State_luaopen_base);
        newXS_deffile("Lua::API::State::luaopen_debug", XS_Lua__API__State_luaopen_debug);
        newXS_deffile("Lua::API::State::luaopen_io", XS_Lua__API__State_luaopen_io);
        newXS_deffile("Lua::API::State::luaopen_math", XS_Lua__API__State_luaopen_math);
        newXS_deffile("Lua::API::State::luaopen_os", XS_Lua__API__State_luaopen_os);
        newXS_deffile("Lua::API::State::luaopen_package", XS_Lua__API__State_luaopen_package);
        newXS_deffile("Lua::API::State::luaopen_string", XS_Lua__API__State_luaopen_string);
        newXS_deffile("Lua::API::State::luaopen_table", XS_Lua__API__State_luaopen_table);
        newXS_deffile("Lua::API::State::checklong", XS_Lua__API__State_checklong);
        newXS_deffile("Lua::API::State::checktype", XS_Lua__API__State_checktype);
        newXS_deffile("Lua::API::State::checkany", XS_Lua__API__State_checkany);
        newXS_deffile("Lua::API::State::argcheck", XS_Lua__API__State_argcheck);
        newXS_deffile("Lua::API::State::checkint", XS_Lua__API__State_checkint);
        newXS_deffile("Lua::API::State::argerror", XS_Lua__API__State_argerror);
        newXS_deffile("Lua::API::State::optinteger", XS_Lua__API__State_optinteger);
        newXS_deffile("Lua::API::State::checklstring", XS_Lua__API__State_checklstring);
        newXS_deffile("Lua::API::State::checkoption", XS_Lua__API__State_checkoption);
        newXS_deffile("Lua::API::State::optint", XS_Lua__API__State_optint);
        newXS_deffile("Lua::API::State::checkudata", XS_Lua__API__State_checkudata);
        newXS_deffile("Lua::API::State::checkstring", XS_Lua__API__State_checkstring);
        newXS_deffile("Lua::API::State::optlong", XS_Lua__API__State_optlong);
        newXS_deffile("Lua::API::State::optlstring", XS_Lua__API__State_optlstring);
        newXS_deffile("Lua::API::State::checknumber", XS_Lua__API__State_checknumber);
        newXS_deffile("Lua::API::State::typerror", XS_Lua__API__State_typerror);
        newXS_deffile("Lua::API::State::optstring", XS_Lua__API__State_optstring);
        newXS_deffile("Lua::API::State::checkinteger", XS_Lua__API__State_checkinteger);
        newXS_deffile("Lua::API::State::optnumber", XS_Lua__API__State_optnumber);
        newXS_deffile("Lua::API::State::openlibs", XS_Lua__API__State_openlibs);
        newXS_deffile("Lua::API::State::buffinit", XS_Lua__API__State_buffinit);
        newXS_deffile("Lua::API::State::callmeta", XS_Lua__API__State_callmeta);
        newXS_deffile("Lua::API::State::dofile", XS_Lua__API__State_dofile);
        newXS_deffile("Lua::API::State::dostring", XS_Lua__API__State_dostring);
        newXS_deffile("Lua::API::State::findtable", XS_Lua__API__State_findtable);
        newXS_deffile("Lua::API::State::getmetafield", XS_Lua__API__State_getmetafield);
        newXS_deffile("Lua::API::State::gsub", XS_Lua__API__State_gsub);
        newXS_deffile("Lua::API::State::loadbuffer", XS_Lua__API__State_loadbuffer);
        newXS_deffile("Lua::API::State::loadfile", XS_Lua__API__State_loadfile);
        newXS_deffile("Lua::API::State::loadstring", XS_Lua__API__State_loadstring);
        newXS_deffile("Lua::API::State::newmetatable", XS_Lua__API__State_newmetatable);
        cv = newXSproto_portable("Lua::API::State::new", XS_Lua__API__State_newstate, file, "$");
        XSANY.any_i32 = 2;
        cv = newXSproto_portable("Lua::API::State::newstate", XS_Lua__API__State_newstate, file, "$");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Lua::API::State::open", XS_Lua__API__State_newstate, file, "$");
        XSANY.any_i32 = 1;
        newXS_deffile("Lua::API::State::ref", XS_Lua__API__State_ref);
        newXS_deffile("Lua::API::State::unref", XS_Lua__API__State_unref);
        newXS_deffile("Lua::API::State::where", XS_Lua__API__State_where);
        cv = newXS_deffile("Lua::API::State::DESTROY", XS_Lua__API__State_DESTROY);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Lua::API::State::close", XS_Lua__API__State_DESTROY);
        XSANY.any_i32 = 1;
        newXS_deffile("Lua::API::State::lua_error", XS_Lua__API__State_lua_error);
        newXS_deffile("Lua::API::State::lua_register", XS_Lua__API__State_lua_register);
        newXS_deffile("Lua::API::State::lua_getmetatable", XS_Lua__API__State_lua_getmetatable);
        newXS_deffile("Lua::API::State::luaL_getmetatable", XS_Lua__API__State_luaL_getmetatable);
        newXS_deffile("Lua::API::State::lua_typename", XS_Lua__API__State_lua_typename);
        newXS_deffile("Lua::API::State::luaL_typename", XS_Lua__API__State_luaL_typename);
        (void)newXSproto_portable("Lua::API::Debug::new", XS_Lua__API__Debug_new, file, "$");
        newXS_deffile("Lua::API::Debug::DESTROY", XS_Lua__API__Debug_DESTROY);
        (void)newXSproto_portable("Lua::API::Debug::event", XS_Lua__API__Debug_event, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::name", XS_Lua__API__Debug_name, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::namewhat", XS_Lua__API__Debug_namewhat, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::what", XS_Lua__API__Debug_what, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::source", XS_Lua__API__Debug_source, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::currentline", XS_Lua__API__Debug_currentline, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::nups", XS_Lua__API__Debug_nups, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::linedefined", XS_Lua__API__Debug_linedefined, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::lastlinedefined", XS_Lua__API__Debug_lastlinedefined, file, "$");
        (void)newXSproto_portable("Lua::API::Debug::short_src", XS_Lua__API__Debug_short_src, file, "$");
        (void)newXSproto_portable("Lua::API::Buffer::new", XS_Lua__API__Buffer_new, file, "$");
        newXS_deffile("Lua::API::Buffer::DESTROY", XS_Lua__API__Buffer_DESTROY);
        newXS_deffile("Lua::API::Buffer::addchar", XS_Lua__API__Buffer_addchar);
        newXS_deffile("Lua::API::Buffer::addlstring", XS_Lua__API__Buffer_addlstring);
        newXS_deffile("Lua::API::Buffer::addsize", XS_Lua__API__Buffer_addsize);
        newXS_deffile("Lua::API::Buffer::addstring", XS_Lua__API__Buffer_addstring);
        newXS_deffile("Lua::API::Buffer::addvalue", XS_Lua__API__Buffer_addvalue);
        newXS_deffile("Lua::API::Buffer::prepbuffer", XS_Lua__API__Buffer_prepbuffer);
        newXS_deffile("Lua::API::Buffer::pushresult", XS_Lua__API__Buffer_pushresult);

    /* Initialisation Section */

#line 424 "API.xs"
{
    MY_CXT_INIT;
    MY_CXT.OOB = newHV();
}

#line 6401 "API.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

